diff -ruN ../nakedmudv2.2/src/scripts/pyroom2.c src/scripts/pyroom2.c
--- ../nakedmudv2.2/src/scripts/pyroom2.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyroom2.c	Fri May 27 01:30:57 2005
@@ -0,0 +1,597 @@
+//*****************************************************************************
+//
+// pyroom.c
+//
+// Contains the implementation of a module that contains all of the methods
+// for dealing with rooms. Also contains a Python Class implementation of
+// NakedMud rooms.
+//
+//*****************************************************************************
+
+#include <Python.h>
+#include <structmember.h>
+
+#include "../mud.h"
+#include "../world.h"
+#include "../room.h"
+#include "../exit.h"
+#include "../character.h"
+#include "../handler.h"
+#include "../utils.h"
+
+#include "pyplugs.h"
+#include "script_set.h"
+#include "script.h"
+#include "pychar.h"
+#include "pyobj.h"
+#include "pyroom.h"
+
+
+
+//*****************************************************************************
+// local structures and defines
+//*****************************************************************************
+
+// a list of the get/setters on the Room class
+LIST *pyroom_getsetters = NULL;
+
+// a list of the methods on the Room class
+LIST *pyroom_methods = NULL;
+
+typedef struct {
+  PyObject_HEAD
+  room_vnum vnum;
+} PyRoom;
+
+
+
+//*****************************************************************************
+// allocation, deallocation, initialization, and comparison
+//*****************************************************************************
+static void
+PyRoom_dealloc(PyRoom *self) {
+  self->ob_type->tp_free((PyObject*)self);
+}
+
+static PyObject *
+PyRoom_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
+    PyRoom *self;
+    self = (PyRoom *)type->tp_alloc(type, 0);
+    self->vnum = NOWHERE;
+    return (PyObject *)self;
+}
+
+static int
+PyRoom_init(PyRoom *self, PyObject *args, PyObject *kwds) {
+  static char *kwlist[] = {"vnum", NULL};
+  int vnum = NOWHERE;
+
+  // get the vnum
+  if (!PyArg_ParseTupleAndKeywords(args, kwds, "i", kwlist, &vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Rooms may only be created using a vnum");
+    return -1;
+  }
+
+  // make sure a room with the vnum exists
+  if(!worldGetRoom(gameworld, vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Room with vnum, %d, does not exist", vnum);
+    return -1;
+  }
+
+  self->vnum = vnum;
+  return 0;
+}
+
+static int
+PyRoom_compare(PyRoom *room1, PyRoom *room2) {
+  if(room1->vnum == room2->vnum)
+    return 0;
+  else if(room1->vnum < room2->vnum)
+    return -1;
+  else
+    return 1;
+}
+
+
+
+//*****************************************************************************
+// getters and setters for the Room class
+//*****************************************************************************
+static PyObject *
+PyRoom_getvnum(PyRoom *self, void *closure) {
+  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+  if(room != NULL) return Py_BuildValue("i", roomGetVnum(room));
+  else             return NULL;
+}
+
+static PyObject *
+PyRoom_getchars(PyRoom *self, PyObject *args) {
+  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL)
+    return NULL;
+  else {
+    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
+    PyObject *list = PyList_New(0);
+    CHAR_DATA *ch;
+
+    // for each char in the room list, add him to a Python list
+    ITERATE_LIST(ch, char_i)
+      PyList_Append(list, newPyChar(ch));
+    deleteListIterator(char_i);
+    return Py_BuildValue("O", list);
+  }
+}
+
+static PyObject *
+PyRoom_getobjs(PyRoom *self, PyObject *args) {
+  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL)
+    return NULL;
+  else {
+    LIST_ITERATOR *obj_i = newListIterator(roomGetContents(room));
+    PyObject *list = PyList_New(0);
+    OBJ_DATA *obj;
+
+    // for each obj in the room list, add him to a Python list
+    ITERATE_LIST(obj, obj_i)
+      PyList_Append(list, newPyObj(obj));
+    deleteListIterator(obj_i);
+    return Py_BuildValue("O", list);
+  }
+}
+
+
+
+//*****************************************************************************
+// methods for the room class
+//*****************************************************************************
+
+//
+// Send a newline-tagged message to everyone in the room
+static PyObject *
+PyRoom_send(PyRoom *self, PyObject *value) {
+  char *mssg = NULL;
+  if (!PyArg_ParseTuple(value, "s", &mssg)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Characters may only be sent strings");
+    return NULL;
+  }
+
+  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+  if(room) {
+    send_to_list(roomGetCharacters(room), "%s\r\n", mssg);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+                    "Tried to send message to nonexistant room, %d.", 
+		    self->vnum);
+    return NULL;
+  }
+}
+
+
+//
+// close a door in the specified direction
+static PyObject *
+PyRoom_close(PyRoom *self, PyObject *value) {
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  char *dirname = NULL;
+  int dir = DIR_NONE;
+
+  if (!PyArg_ParseTuple(value, "s", &dirname)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Doornames provided to PyRoom_close must be directions.");
+    return NULL;
+  }
+
+  room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to close door in non-existant room, %d.", 
+		 self->vnum);
+    return NULL;
+  }
+
+  // see if it's a normal exit
+  dir = dirGetNum(dirname);
+
+  if(dir != DIR_NONE)
+    exit = roomGetExit(room, dir);
+  else
+    exit = roomGetExitSpecial(room, dirname);
+
+  // make sure the exit exists
+  if(exit == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to close non-existant exit, %s, in room %d.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  // make sure the exit can be closed in the first place
+  if(!exitIsClosable(exit)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to close exit, %s, in room %d that is not closable.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  exitSetClosed(exit, TRUE);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// lock a door in the specified direction
+static PyObject *
+PyRoom_lock(PyRoom *self, PyObject *value) {
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  char *dirname = NULL;
+  int dir = DIR_NONE;
+
+  if (!PyArg_ParseTuple(value, "s", &dirname)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Doornames provided to PyRoom_lock must be directions.");
+    return NULL;
+  }
+
+  room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to lock door in non-existant room, %d.", 
+		 self->vnum);
+    return NULL;
+  }
+
+  // see if it's a normal exit
+  dir = dirGetNum(dirname);
+
+  if(dir != DIR_NONE)
+    exit = roomGetExit(room, dir);
+  else
+    exit = roomGetExitSpecial(room, dirname);
+
+  // make sure the exit exists
+  if(exit == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to lock non-existant exit, %s, in room %d.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  // make sure the exit can be closed in the first place
+  if(!exitIsClosable(exit)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to lock exit, %s, in room %d that is not closable.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+  if(exitGetKey(exit) == NOTHING) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to lock exit, %s, in room %d that is not lockable.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  exitSetClosed(exit, TRUE);
+  exitSetLocked(exit, TRUE);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// lock a door in the specified direction
+static PyObject *
+PyRoom_unlock(PyRoom *self, PyObject *value) {
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  char *dirname = NULL;
+  int dir = DIR_NONE;
+
+  if (!PyArg_ParseTuple(value, "s", &dirname)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Doornames provided to PyRoom_unlock must be directions.");
+    return NULL;
+  }
+
+  room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to unlock door in non-existant room, %d.", 
+		 self->vnum);
+    return NULL;
+  }
+
+  // see if it's a normal exit
+  dir = dirGetNum(dirname);
+
+  if(dir != DIR_NONE)
+    exit = roomGetExit(room, dir);
+  else
+    exit = roomGetExitSpecial(room, dirname);
+
+  // make sure the exit exists
+  if(exit == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to unlock non-existant exit, %s, in room %d.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  // make sure the exit can be closed in the first place
+  if(!exitIsClosable(exit)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to unlock exit, %s, in room %d that is not closable.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+  if(exitGetKey(exit) == NOTHING) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to unlock exit, %s, in room %d that is not lockable.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  exitSetLocked(exit, FALSE);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// close a door in the specified direction
+static PyObject *
+PyRoom_open(PyRoom *self, PyObject *value) {
+  ROOM_DATA *room = NULL;
+  EXIT_DATA *exit = NULL;
+  char *dirname = NULL;
+  int dir = DIR_NONE;
+
+  if (!PyArg_ParseTuple(value, "s", &dirname)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Doornames provided to PyRoom_open must be directions.");
+    return NULL;
+  }
+
+  room = worldGetRoom(gameworld, self->vnum);
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to open door in non-existant room, %d.", 
+		 self->vnum);
+    return NULL;
+  }
+
+
+  // see if it's a normal exit
+  dir = dirGetNum(dirname);
+
+  if(dir != DIR_NONE)
+    exit = roomGetExit(room, dir);
+  else
+    exit = roomGetExitSpecial(room, dirname);
+
+  // make sure the exit exists
+  if(exit == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to open non-existant exit, %s, in room %d.",
+		 dirname, self->vnum);
+    return NULL;
+  }
+
+  exitSetClosed(exit, FALSE);
+  exitSetLocked(exit, FALSE);
+  return Py_BuildValue("i", 1);
+}
+
+
+static PyObject *
+PyRoom_attach(PyRoom *self, PyObject *args) {  
+  long vnum = NOTHING;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "i", &vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "To attach a script, the vnum must be supplied.");
+    return NULL;
+  }
+
+  // pull out the character and do the attaching
+  ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+  SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+  if(room != NULL && script != NULL) {
+    scriptSetAdd(roomGetScripts(room), vnum);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to attach script to nonexistant room, %d, or script %d "
+		 "does not exit.", self->vnum, (int)vnum);
+    return NULL;
+  }
+}
+
+
+static PyObject *
+PyRoom_detach(PyRoom *self, PyObject *args) {  
+  long vnum = NOTHING;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "i", &vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "To detach a script, the vnum must be suppplied.");
+    return NULL;
+  }
+
+  // pull out the character and do the attaching
+  ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+  SCRIPT_DATA *script = worldGetScript(gameworld, (int)vnum);
+  if(room != NULL && script != NULL) {
+    scriptSetRemove(roomGetScripts(room), vnum);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to detach script from nonexistant room, %d, or script "
+		 "%d does not exit.", self->vnum, (int)vnum);
+    return NULL;
+  }
+}
+
+
+
+//*****************************************************************************
+// structures to define our methods and classes
+//*****************************************************************************
+static PyTypeObject PyRoom_Type = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "room.Room",               /*tp_name*/
+    sizeof(PyRoom),            /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)PyRoom_dealloc,/*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    (cmpfunc)PyRoom_compare,   /*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "Python Room object",      /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    0,                         /* tp_methods */
+    0,                         /* tp_members */
+    0,                         /* tp_getset */ 
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)PyRoom_init,     /* tp_init */
+    0,                         /* tp_alloc */
+    PyRoom_new,                /* tp_new */
+};
+
+static PyMethodDef room_module_methods[] = {
+  {NULL, NULL, 0, NULL}  /* Sentinel */
+};
+
+
+
+//*****************************************************************************
+// implementation of pyroom.h
+//*****************************************************************************
+
+void PyRoom_addGetSetter(const char *name, void *g, void *s, const char *doc) {
+  // make sure our list of get/setters is created
+  if(pyroom_getsetters == NULL) pyroom_getsetters = newList();
+
+  // make the GetSetter def
+  PyGetSetDef *def = calloc(1, sizeof(PyGetSetDef));
+  def->name        = strdup(name);
+  def->get         = (getter)g;
+  def->set         = (setter)s;
+  def->doc         = (doc ? strdup(doc) : NULL);
+  def->closure     = NULL;
+  listPut(pyroom_getsetters, def);
+}
+
+
+void PyRoom_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pyroom_methods == NULL) pyroom_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyroom_methods, def);
+}
+
+
+// initialize rooms for use. This must be called AFTER 
+PyMODINIT_FUNC
+init_PyRoom(void) {
+    PyObject* module = NULL;
+
+    // add all of the basic getsetters
+    PyRoom_addGetSetter("vnum",  PyRoom_getvnum,   NULL, "The room's vnum");
+    PyRoom_addGetSetter("chars", PyRoom_getchars,  NULL, "chars in the room");
+    PyRoom_addGetSetter("objs",  PyRoom_getobjs,   NULL, "objects in the room");
+    PyRoom_addGetSetter("contents",PyRoom_getobjs, NULL, "objects in the room");
+
+    // add all of the basic methods
+    PyRoom_addMethod("attach", PyRoom_attach, METH_VARARGS,
+		     "attach a new script to the room.");
+    PyRoom_addMethod("detach", PyRoom_detach, METH_VARARGS,
+		     "detach a script from the room, by vnum.");
+    PyRoom_addMethod("close", PyRoom_close, METH_VARARGS,
+		     "close a door in the specified direction.");
+    PyRoom_addMethod("open", PyRoom_open, METH_VARARGS,
+		     "open a door in the specified direction. Also unlocks.");
+    PyRoom_addMethod("lock", PyRoom_lock, METH_VARARGS,
+		     "lock a door in the specified direction. Also closes.");
+    PyRoom_addMethod("unlock", PyRoom_unlock, METH_VARARGS,
+		     "unlocks a door in the specified direction.");
+    PyRoom_addMethod("send", PyRoom_send, METH_VARARGS,
+		     "send a message to everyone in the room.");
+
+    // add in all the getsetters and methods
+    makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
+    deleteListWith(pyroom_getsetters, free); pyroom_getsetters = NULL;
+    deleteListWith(pyroom_methods,    free); pyroom_methods    = NULL;
+
+    // make sure the room class is ready to be made
+    if (PyType_Ready(&PyRoom_Type) < 0)
+        return;
+
+    // initialize the module
+    module = Py_InitModule3("room", room_module_methods,
+			    "The room module, for all MUD room-related stuff.");
+
+    // make sure the module parsed OK
+    if (module == NULL)
+      return;
+
+    // add the Room class to the room module
+    PyModule_AddObject(module, "Room", (PyObject *)&PyRoom_Type);
+    Py_INCREF(&PyRoom_Type);
+}
+
+
+int PyRoom_AsVnum(PyObject *room) {
+  return ((PyRoom *)room)->vnum;
+}
+
+ROOM_DATA *PyRoom_AsRoom(PyObject *room) {
+  return worldGetRoom(gameworld, PyRoom_AsVnum(room));
+}
+
+int PyRoom_Check(PyObject *value) {
+  return PyObject_TypeCheck(value, &PyRoom_Type);
+}
+
+PyObject *
+newPyRoom(ROOM_DATA *room) {
+  PyRoom *py_room = (PyRoom *)PyRoom_new(&PyRoom_Type, NULL, NULL);
+  py_room->vnum = roomGetVnum(room);
+  return (PyObject *)py_room;
+}
diff -ruN ../nakedmudv2.2/src/scripts/pyroom2.d src/scripts/pyroom2.d
--- ../nakedmudv2.2/src/scripts/pyroom2.d	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyroom2.d	Fri May 27 01:30:57 2005
@@ -0,0 +1,4 @@
+scripts/pyroom2.d scripts/pyroom2.o: scripts/pyroom2.c mud.h wrapsock.h property_table.h list.h \
+  map.h hashtable.h set.h buffer.h bitvector.h world.h room.h exit.h \
+  character.h handler.h utils.h scripts/pyplugs.h scripts/script_set.h \
+  scripts/script.h scripts/pychar.h scripts/pyobj.h scripts/pyroom.h
diff -ruN ../nakedmudv2.2/src/scripts/script.c src/scripts/script.c
--- ../nakedmudv2.2/src/scripts/script.c	Thu May 12 17:08:51 2005
+++ src/scripts/script.c	Fri May 27 01:30:57 2005
@@ -28,6 +28,7 @@
 #include "pyroom.h"
 #include "pyobj.h"
 #include "pymud.h"
+#include "pyplugs.h"
 
 // online editor stuff
 #include "../editor/editor.h"
@@ -37,7 +38,7 @@
 
 
 //*****************************************************************************
-// local functions and commands
+// local functions, variables, and commands
 //*****************************************************************************
 
 //
@@ -59,8 +60,8 @@
       send_to_char(ch, "No script with that vnum exists!\r\n");
     else if(scriptGetType(script) != SCRIPT_TYPE_RUNNABLE)
       send_to_char(ch, "That script is not runnable!\r\n");
-    else if(charGetLevel(ch) < scriptGetNumArg(script))
-      send_to_char(ch, "You are not high enough level to run that script!\r\n");
+    else if(!bitIsSet(charGetUserGroups(ch), mudsettingGetString("lockdown")))
+      send_to_char(ch, "You do not have the priviledges to run that script!\r\n");
     else {
       send_to_char(ch, "Ok.\r\n");
       run_script(scriptGetCode(script), ch, SCRIPTOR_CHAR, NULL, NULL, NULL,
@@ -333,62 +334,6 @@
 
 
 //
-// Python makes it overly complicated (IMO) to get traceback information when
-// running in C. I spent some time hunting around, and came across a lovely
-// site that provided me with this function for getting a traceback of an error.
-// The site that provided this piece of code to me is located here:
-//   http://stompstompstomp.com/weblog/technical/2004-03-29
-char* getPythonTraceback()
-{
-    // Python equivilant:
-    // import traceback, sys
-    // return "".join(traceback.format_exception(sys.exc_type, 
-    //    sys.exc_value, sys.exc_traceback))
-
-    PyObject *type, *value, *traceback;
-    PyObject *tracebackModule;
-    char *chrRetval;
-
-    PyErr_Fetch(&type, &value, &traceback);
-
-    tracebackModule = PyImport_ImportModule("traceback");
-    if (tracebackModule != NULL)
-    {
-        PyObject *tbList, *emptyString, *strRetval;
-
-        tbList = PyObject_CallMethod(
-            tracebackModule, 
-            "format_exception", 
-            "OOO",
-            type,
-            value == NULL ? Py_None : value,
-            traceback == NULL ? Py_None : traceback);
-
-        emptyString = PyString_FromString("");
-        strRetval = PyObject_CallMethod(emptyString, "join", 
-            "O", tbList);
-
-        chrRetval = strdup(PyString_AsString(strRetval));
-
-        Py_DECREF(tbList);
-        Py_DECREF(emptyString);
-        Py_DECREF(strRetval);
-        Py_DECREF(tracebackModule);
-    }
-    else
-    {
-        chrRetval = strdup("Unable to import traceback module.");
-    }
-
-    Py_DECREF(type);
-    Py_XDECREF(value);
-    Py_XDECREF(traceback);
-
-    return chrRetval;
-}
-
-
-//
 // Return a new dictionary with all the basic modules imported
 PyObject *newScriptDict() {
   PyObject* dict = PyDict_New();
@@ -463,12 +408,15 @@
   // initialize python
   Py_Initialize();
 
-  // initialize modules
+  // initialize all of our modules written in C
   init_PyChar();
   init_PyRoom();
   init_PyObj();
   init_PyMud();
 
+  // initialize all of our modules written in Python
+  init_pyplugs();
+
 
   // initialize our auxiliary data
   auxiliariesInstall("script_aux_data",
@@ -480,9 +428,9 @@
 
   extern COMMAND(cmd_scedit); // define the command
   add_cmd("scedit", NULL, cmd_scedit, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_SCRIPTER, FALSE, TRUE);
+	  "scripter", FALSE, TRUE);
   add_cmd("scrun", NULL, cmd_scrun, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
 
   init_script_editor();
 }
@@ -558,10 +506,11 @@
 
 
 //
-// Control we need to highlight
-//
+// statements we need to highlight
 const char *control_table[] = {
+  "import",
   "while",
+  "from",
   "elif",
   "else",
   "def",
diff -ruN ../nakedmudv2.2/src/scripts/script.d src/scripts/script.d
--- ../nakedmudv2.2/src/scripts/script.d	Thu May 12 17:08:51 2005
+++ src/scripts/script.d	Fri May 27 01:33:34 2005
@@ -0,0 +1,6 @@
+scripts/script.d scripts/script.o: scripts/script.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h utils.h socket.h world.h \
+  character.h room.h object.h storage.h auxiliary.h scripts/script.h \
+  scripts/script_set.h scripts/pychar.h scripts/pyroom.h scripts/pyobj.h \
+  scripts/pymud.h scripts/pyplugs.h editor/editor.h \
+  scripts/script_editor.h olc2/olc.h
diff -ruN ../nakedmudv2.2/src/scripts/script.h src/scripts/script.h
--- ../nakedmudv2.2/src/scripts/script.h	Thu May 12 17:08:51 2005
+++ src/scripts/script.h	Fri May 27 01:30:57 2005
@@ -13,7 +13,8 @@
 // This must be put at the top of mud.h so the rest of the MUD knows that
 // we've got the scripts module installed
 // #define MODULE_SCRIPTS
-//
+
+
 
 //*****************************************************************************
 //                            SCRIPT DOCUMENTATION
@@ -140,10 +141,9 @@
 //   Description:
 //     Gods can use scrun to run a script of this type
 //   Arguments:
-//     The Arguments to be passed to the script
+//     The user groups allowed to run the script
 //   Numeric Arguments:
-//     Argument is the minimum level of a person who is allowed to 
-//     run this this script
+//     None
 //   Works with:
 //     mobiles (gods)
 //   Parameters:
diff -ruN ../nakedmudv2.2/src/scripts/script_edit.c src/scripts/script_edit.c
--- ../nakedmudv2.2/src/scripts/script_edit.c	Thu May 12 17:08:51 2005
+++ src/scripts/script_edit.c	Fri May 27 01:30:57 2005
@@ -117,12 +117,25 @@
     olc_display_table(sock, scriptTypeName, NUM_SCRIPTS, 1);
     text_to_buffer(sock, "Pick a script type: ");
     return SCEDIT_TYPE;
-  case '3':
-    text_to_buffer(sock, "Enter new arguments: ");
-    return SCEDIT_ARGS;
   case '5':
     socketStartEditor(sock, script_editor,scriptGetCodeBuffer(script));
     return MENU_NOCHOICE;
+  case '3':
+    switch(scriptGetType(script)) {
+    case SCRIPT_TYPE_SPEECH:
+      text_to_buffer(sock, "Enter speech patterns (comma-separated) "
+		     "that trigger this script: ");
+      return SCEDIT_ARGS;
+    case SCRIPT_TYPE_RUNNABLE:
+      text_to_buffer(sock, "Enter user groups allowed to run this script: ");
+      return SCEDIT_ARGS;
+    default:
+      send_to_socket(sock, 
+		     "This script type does not use string arguments.\r\n"
+		     "Enter choice (Q to quit) : ");
+      return MENU_NOCHOICE;
+    }
+
   case '4':
     switch(scriptGetType(script)) {
       // 0 = triggers always
@@ -137,11 +150,6 @@
 		     "Enter choice : ");
       return SCEDIT_NARG;
 
-    case SCRIPT_TYPE_RUNNABLE:
-      send_to_socket(sock,
-		     "Enter the minimum level that can run this script: ");
-      return SCEDIT_NARG;
-
     case SCRIPT_TYPE_COMMAND:
       send_to_socket(sock,
 		     "Control for the actual MUD command:\r\n"
@@ -187,10 +195,6 @@
       // 1 = cancel normal command
     case SCRIPT_TYPE_COMMAND:
       scriptSetNumArg(script, MIN(1, MAX(0, atoi(arg))));
-      break;
-      // narg = minimum level that can run this script
-    case SCRIPT_TYPE_RUNNABLE:
-      scriptSetNumArg(script, MIN(MAX_LEVEL, MAX(0, atoi(arg))));
       break;
     }
     return TRUE;
diff -ruN ../nakedmudv2.2/src/set_val/set_val.c src/set_val/set_val.c
--- ../nakedmudv2.2/src/set_val/set_val.c	Thu May 12 17:08:51 2005
+++ src/set_val/set_val.c	Fri May 27 01:59:11 2005
@@ -35,6 +35,21 @@
 
 
 //*****************************************************************************
+// setter functions
+//*****************************************************************************
+
+//
+// most everything already has a setter function done up, but because user
+// groups go through a bitvector, we need an extra function to get in and be
+// able to set a character's groups...
+void charSetUserGroups(CHAR_DATA *ch, const char *groups) {
+  bitClear(charGetUserGroups(ch));
+  bitSet(charGetUserGroups(ch), groups);
+}
+
+
+
+//*****************************************************************************
 // local defines, datastructures, functions, and commands
 //*****************************************************************************
 HASHTABLE *char_set_table = NULL;
@@ -100,14 +115,6 @@
 }
 
 
-//
-// used for setting; make sure the value we're trying to set is in an
-// acceptable range.
-//
-bool isLevel(int level) {
-  return (level >= LEVEL_PLAYER && level <= MAX_LEVEL);
-}
-
 // are we trying to set a value from an argument, or from our notepad?
 #define SET_SUBCMD_SET        0
 #define SET_SUBCMD_SETPAD     1
@@ -159,8 +166,8 @@
 		       FIND_SCOPE_ALL | FIND_SCOPE_VISIBLE, FALSE, &found);
 
     if(found == FOUND_CHAR) {
-      if(charGetLevel(ch) <= charGetLevel(tgt) && ch != tgt)
-	send_to_char(ch, "Sorry, %s is too high a level!\r\n", 
+      if(!charHasMoreUserGroups(ch, tgt))
+	send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
 		     see_char_as(ch, tgt));
       else
 	try_set(ch, tgt, char_set_table, field, val);
@@ -196,38 +203,38 @@
   /************************************************************/
 
   // PLAYER SETS
-  add_set("desc",  LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING, charSetDesc, NULL);
-  add_set("rdesc", LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING, charSetRdesc,NULL);
-  add_set("name",  LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING, charSetName, NULL);
-  add_set("mrdesc",LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING, charSetMultiRdesc, NULL);
-  add_set("mname", LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING, charSetMultiName, NULL);
-  add_set("keywords",LEVEL_BUILDER,SET_CHAR,SET_TYPE_STRING, charSetKeywords, NULL);
-  add_set("dialog",LEVEL_BUILDER, SET_CHAR, SET_TYPE_INT, charSetDialog,  NULL);
-  add_set("level", LEVEL_ADMIN,   SET_CHAR, SET_TYPE_INT, charSetLevel,isLevel);
-  add_set("race",  LEVEL_BUILDER, SET_CHAR, SET_TYPE_STRING,charSetRace,isRace);
+  add_set("desc",     SET_CHAR, SET_TYPE_STRING, charSetDesc,         NULL);
+  add_set("rdesc",    SET_CHAR, SET_TYPE_STRING, charSetRdesc,        NULL);
+  add_set("name",     SET_CHAR, SET_TYPE_STRING, charSetName,         NULL);
+  add_set("mrdesc",   SET_CHAR, SET_TYPE_STRING, charSetMultiRdesc,   NULL);
+  add_set("mname",    SET_CHAR, SET_TYPE_STRING, charSetMultiName,    NULL);
+  add_set("keywords", SET_CHAR, SET_TYPE_STRING, charSetKeywords,     NULL);
+  add_set("dialog",   SET_CHAR, SET_TYPE_INT,    charSetDialog,       NULL);
+  add_set("race",     SET_CHAR, SET_TYPE_STRING, charSetRace,       isRace);
+  add_set("groups",   SET_CHAR, SET_TYPE_STRING, charSetUserGroups,   NULL);
 
   // ROOM SETS
-  add_set("name", LEVEL_BUILDER, SET_ROOM, SET_TYPE_STRING, roomSetName, NULL);
-  add_set("desc", LEVEL_BUILDER, SET_ROOM, SET_TYPE_STRING, roomSetDesc, NULL);
+  add_set("name",     SET_ROOM, SET_TYPE_STRING, roomSetName,         NULL);
+  add_set("desc",     SET_ROOM, SET_TYPE_STRING, roomSetDesc,         NULL);
 
   // OBJECT SETS
-  add_set("name",    LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetName, NULL);
-  add_set("desc",    LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetDesc, NULL);
-  add_set("rdesc",   LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetRdesc,NULL);
-  add_set("name",    LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetName, NULL);
-  add_set("mrdesc",  LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetMultiRdesc, NULL);
-  add_set("mname",   LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetMultiName, NULL);
-  add_set("keywords",LEVEL_BUILDER,SET_OBJECT,SET_TYPE_STRING,objSetKeywords, NULL);
+  add_set("name",     SET_OBJECT,SET_TYPE_STRING,objSetName,          NULL);
+  add_set("desc",     SET_OBJECT,SET_TYPE_STRING,objSetDesc,          NULL);
+  add_set("rdesc",    SET_OBJECT,SET_TYPE_STRING,objSetRdesc,         NULL);
+  add_set("name",     SET_OBJECT,SET_TYPE_STRING,objSetName,          NULL);
+  add_set("mrdesc",   SET_OBJECT,SET_TYPE_STRING,objSetMultiRdesc,    NULL);
+  add_set("mname",    SET_OBJECT,SET_TYPE_STRING,objSetMultiName,     NULL);
+  add_set("keywords", SET_OBJECT,SET_TYPE_STRING,objSetKeywords,      NULL);
 
   // now, add the admin commands for working with set
   add_cmd("set", NULL, cmd_set, SET_SUBCMD_SET, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
   add_cmd("setpad", NULL, cmd_set, SET_SUBCMD_SETPAD, POS_UNCONCIOUS,POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
 }
 
 
-void add_set(const char *name, int min_lev, int set_for, int type, void *setter, void *checker) {
+void add_set(const char *name, int set_for, int type, void *setter, void *checker) {
   HASHTABLE *table = NULL;
   // first, find our table
   if     (set_for == SET_CHAR)   table = char_set_table;
diff -ruN ../nakedmudv2.2/src/set_val/set_val.h src/set_val/set_val.h
--- ../nakedmudv2.2/src/set_val/set_val.h	Thu May 12 17:08:51 2005
+++ src/set_val/set_val.h	Fri May 27 01:30:57 2005
@@ -26,7 +26,6 @@
 
 //
 // prepare the set utility for use
-//
 void init_set();
 
 
@@ -38,7 +37,7 @@
 // can be set, checker should be provided. It takes in the to-be-set value and
 // makes sure it is OK, returning TRUE if it is and FALSE if it is not. The
 // checker function should be of the form:
-//
-void add_set(const char *name, int min_lev, int set_for, int type, void *setter, void *checker);
+//    bool checker(datatype newval)
+void add_set(const char *name, int set_for, int type, void *setter, void *checker);
 
 #endif // SET_VAL_H
